//--------------------------------------------------------------------------------------- 
//  FILE:    X2Effect_Cutthroat
//  AUTHOR:  John Lumpkin (Long War Studios)
//  PURPOSE: Sets up crit and Armor piercing bonus
//--------------------------------------------------------------------------------------- 

class X2Effect_Cutthroat extends X2Effect_Persistent config (LW_PerkPack);

var config int CUTTHROAT_BONUS_CRIT_CHANCE;

function GetToHitModifiers(XComGameState_Effect EffectState, XComGameState_Unit Attacker, XComGameState_Unit Target, XComGameState_Ability AbilityState, class<X2AbilityToHitCalc> ToHitType, bool bMelee, bool bFlanking, bool bIndirectFire, out array<ShotModifierInfo> ShotModifiers)
{
    local XComGameState_Item	SourceWeapon;
    local ShotModifierInfo		ShotInfo;

    if(AbilityState.GetMyTemplate().IsMelee())
	{
		if (Target != none && !Target.IsRobotic())
		{
			SourceWeapon = AbilityState.GetSourceWeapon();
			if (SourceWeapon != none)
			{
				ShotInfo.ModType = eHit_Crit;
				ShotInfo.Reason = FriendlyName;
				ShotInfo.Value = default.CUTTHROAT_BONUS_CRIT_CHANCE;
				ShotModifiers.AddItem(ShotInfo);
			}
		}
	}
}

function int GetExtraArmorPiercing(XComGameState_Effect EffectState, XComGameState_Unit Attacker, Damageable TargetDamageable, XComGameState_Ability AbilityState, const out EffectAppliedData AppliedData)
{
	local XComGameState_Item		SourceWeapon;
	local XComGameState_Unit		Target;

	if(AbilityState.GetMyTemplate().IsMelee())
	{
		Target = XComGameState_Unit(`XCOMHISTORY.GetGameStateForObjectID(AppliedData.TargetStateObjectRef.ObjectID));
		if (Target != none && !Target.IsRobotic())
		{		
			SourceWeapon = AbilityState.GetSourceWeapon();
			if (SourceWeapon != none)
			{				
				return int(Target.GetArmorMitigationForUnitFlag());
			}
		}
	}	
	return 0;
}

defaultproperties
{
    DuplicateResponse=eDupe_Allow
    EffectName="Cutthroat"
}

