//--------------------------------------------------------------------------------------- 
//  FILE:    X2Effect_GrazingFire
//  AUTHOR:  John Lumpkin (Long War Studios)
//  PURPOSE: Sets up Grazing Fire -- enemy must make saving throw versus dodge to avoid
// being grazed on a miss
//--------------------------------------------------------------------------------------- 

class X2Effect_GrazingFire extends X2Effect_Persistent config (LW_PerkPack);

var int SuccessChance;

function bool ChangeHitResultForAttacker(XComGameState_Unit Attacker, XComGameState_Unit TargetUnit, XComGameState_Ability AbilityState, const EAbilityHitResult CurrentResult, out EAbilityHitResult NewHitResult)
{
	local int randroll, hitchance;

	if (AbilityState.GetSourceWeapon() == Attacker.GetItemInSlot(eInvSlot_PrimaryWeapon))
	{
		if (class'XComGameStateContext_Ability'.static.IsHitResultMiss(CurrentResult))
		{
			RandRoll = `SYNC_RAND(100);
			HitChance = SuccessChance - TargetUnit.GetCurrentStat(eStat_Dodge);
			if (Randroll <= HitChance)
				NewHitResult = eHit_Graze;
			return true;
		}
	}
	return false;
}