class X2Effect_MindMerge extends X2Effect_ModifyStats;

var float BaseWillincrease;
var float BaseShieldHPIncrease;
var float MindMergeWillDivisor;
var float MindMergeShieldHPDivisor;
var float SoulMergeWillDivisor;
var float SoulMergeShieldHPDivisor;
var float AmpMGWillBonus;
var float AmpMGShieldHPBonus;
var float AmpBMWillBonus;
var float AmpBMShieldHPBonus;

protected simulated function OnEffectAdded(const out EffectAppliedData ApplyEffectParameters, XComGameState_BaseObject kNewTargetState, XComGameState NewGameState, XComGameState_Effect NewEffectState)
{
	local StatChange			WillChange;
	local StatChange			ShieldHPChange;
	local XComGameState_Unit	Caster;
	local XComGameState_Item	SourceItem;
	local StateObjectReference	SoulMergeRef;

	WillChange.StatType = eStat_Will;
	ShieldHPChange.StatType = eStat_ShieldHP;

	Caster = XComGameState_Unit (NewGameState.GetGameStateForObjectID(ApplyEffectParameters.SourceStateObjectRef.ObjectID));
    if(Caster == none)
    {
        Caster = XComGameState_Unit(class'XComGameStateHistory'.static.GetGameStateHistory().GetGameStateForObjectID(ApplyEffectParameters.SourceStateObjectRef.ObjectID));
    }
	SourceItem = XComGameState_Item(NewGameState.GetGameStateForObjectID(ApplyEffectParameters.ItemStateObjectRef.ObjectID));
	if(SourceItem == none)
    {
        SourceItem = XComGameState_Item(class'XComGameStateHistory'.static.GetGameStateHistory().GetGameStateForObjectID(ApplyEffectParameters.ItemStateObjectRef.ObjectID));
    }
	
	SoulMergeRef = Caster.FindAbility('SoulMerge');
	if (SoulMergeRef.ObjectID == 0)
	{
		WillChange.StatAmount = BaseWillIncrease + (Caster.GetCurrentStat(eStat_PsiOffense) / MindMergeWillDivisor);
		ShieldHPChange.StatAmount = BaseShieldHPIncrease + (Caster.GetCurrentStat(eStat_PsiOffense) / MindMergeShieldHPDivisor);
	}
	else
	{
		WillChange.StatAmount = BaseWillIncrease + (Caster.GetCurrentStat(eStat_PsiOffense) / SoulMergeWillDivisor);
		ShieldHPChange.StatAmount = BaseShieldHPIncrease + (Caster.GetCurrentStat(eStat_PsiOffense) / SoulMergeShieldHPDivisor);
	}

	if (SourceItem.GetMyTemplateName() == 'PsiAmp_MG')
	{
		WillChange.StatAmount += AmpMGWillBonus;
		ShieldHPChange.StatAmount += AmpMGShieldHPBonus;
	}
	if (SourceItem.GetMyTemplateName() == 'PsiAmp_BM')
	{
		WillChange.StatAmount += AmpBMWillBonus;
		ShieldHPChange.StatAmount += AmpBMShieldHPBonus;
	}
		
	NewEffectState.StatChanges.AddItem(WillChange);
	NewEffectState.StatChanges.AddItem(ShieldHPChange);

	super.OnEffectAdded(ApplyEffectParameters, kNewTargetState, NewGameState, NewEffectState);
}

